CREATE OR REPLACE TRIGGER LOG_SUP_DATAEMBARQUEOL
AFTER INSERT OR UPDATE OR DELETE ON  DATAEMBARQUEOL
FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIOPELOG, 'X') <> NVL(:NEW.CDFILIOPELOG, 'X')) THEN
         V_DESC := 'Fil. OL: ' ||''|| NVL(:NEW.CDFILIOPELOG,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDFILIAL, 'X') <> NVL(:NEW.CDFILIAL, 'X')) THEN
         V_DESC := 'Fil. Dest.: ' ||''|| NVL(:NEW.CDFILIAL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDPRODUTO, 'X') <> NVL(:NEW.CDPRODUTO, 'X')) THEN
         V_DESC := 'Nvel Prod.: ' ||''|| NVL(:NEW.CDPRODUTO,'') ||'   ';
      END IF;
      IF (NVL(:OLD.NRDIAEMBARQUE,  'X') <> NVL(:NEW.NRDIAEMBARQUE,  'X')) THEN
         V_DESC := 'N. Dias: ' ||''|| NVL(:NEW.NRDIAEMBARQUE,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDSOMENTEUTIL,  'X') <> NVL(:NEW.IDSOMENTEUTIL,  'X')) THEN
         V_DESC := 'Util. Dias teis:' ||''|| NVL(:NEW.IDSOMENTEUTIL,'') ||'   ';
      END IF;
      V_ITPESQ       := :NEW.CDFILIOPELOG||:NEW.CDFILIAL||:NEW.CDPRODUTO;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   :=        'Fil. OL'                ||''  || NVL(:NEW.CDFILIOPELOG,'')   ||'  '  ||
                            'Fil. Dest.:'            ||''  || NVL(:NEW.CDFILIAL,'')       ||'  '  ||
                            'Nvel Prod.: '          ||''  || NVL(:NEW.CDPRODUTO,'')      ||'  '  ||
                            'N. Dias:'               ||''  || NVL(:NEW.NRDIAEMBARQUE,'')  ||'  '  ||
                            'Util. Dias teis:'      ||''  || NVL(:NEW.IDSOMENTEUTIL,'');
         V_ITPESQ       := :NEW.CDFILIOPELOG|| :NEW.CDFILIAL||:NEW.CDPRODUTO;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC   :=     'Fil. OL'                ||''  || NVL(:OLD.CDFILIOPELOG,'')   ||'  '  ||
                            'Fil. Dest.:'            ||''  || NVL(:OLD.CDFILIAL,'')       ||'  '  ||
                            'Nvel Prod.: '          ||''  || NVL(:OLD.CDPRODUTO,'')      ||'  '  ||
                            'N. Dias:'               ||''  || NVL(:OLD.NRDIAEMBARQUE,'')  ||'  '  ||
                            'Util. Dias teis:'      ||''  || NVL(:OLD.IDSOMENTEUTIL,'');
            V_ITPESQ       := :OLD.CDFILIOPELOG||:OLD.CDFILIAL||:OLD.CDPRODUTO;
            V_IDTIPOOPER   := '3';
         END IF;
      END IF;
   END IF;
   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 400);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER)
      VALUES
         ('DATAEMBARQUEOL',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_DATAEMBARQUEOL','5.65.XXX'); END;
/
